<script lang="ts">
import Vue from 'vue';
import SlpHorizontalRule from './horizontal-rule.vue';

export default Vue.extend({
  name: 'CTA',
  components: {
    SlpHorizontalRule,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
  },
  computed: {
    hasButtons(): boolean {
      return this.data.free_trial_button || this.data.contact_sales_button;
    },
  },
});
</script>

<template>
  <section
    class="cta"
    :class="{
      'cta--no-image': !data.image,
      'no-margin-bottom': data.no_margin_bottom,
    }"
    :data-aos="data.aos_animation"
    :data-aos-duration="data.aos_duration"
  >
    <SlpRow>
      <SlpColumn
        :cols="data.image ? 6 : null"
        class="slp-flex slp-align-items-center"
      >
        <div class="cta__body" :class="{ 'cta__body--no-image': !data.image }">
          <div
            :class="{
              'slp-mb-32': hasButtons,
              centered: data.centered_by_default,
            }"
            class="cta__header"
          >
            <SlpTypography
              tag="h1"
              variant="heading1"
              :class="{
                'cta__title-image': !data.image && !data.hide_title_image,
              }"
              >{{ data.title }}</SlpTypography
            >
            <SlpTypography
              v-if="data.subtitle"
              tag="p"
              variant="heading4"
              class="cta__subtitle"
            >
              <span v-html="$md.render(data.subtitle)"></span>
            </SlpTypography>
            <SlpTypography
              v-if="data.body_text"
              tag="p"
              variant="body1"
              class="slp-text-base cta__body--text"
              >{{ data.body_text }}</SlpTypography
            >
          </div>
          <div
            v-if="hasButtons"
            class="slp-mb-32 cta__buttons"
            :class="{ centered: data.centered_by_default }"
          >
            <SlpButton
              v-if="data.free_trial_button"
              class="slp-mr-8"
              variant="primary"
              :data-ga-name="
                data.free_trial_button.data_ga_name || 'free trial'
              "
              :data-ga-location="
                data.free_trial_button.data_ga_location || 'header'
              "
              :href="data.free_trial_button.url || '/free-trial/'"
              >{{ data.free_trial_button.text || 'Get free trial' }}</SlpButton
            >
            <SlpButton
              v-if="data.contact_sales_button"
              variant="secondary"
              :href="data.contact_sales_button.url || '/sales/'"
              :data-ga-name="
                data.contact_sales_button.data_ga_name || 'contact sales'
              "
              :data-ga-location="
                data.contact_sales_button.data_ga_location || 'header'
              "
              >{{
                data.contact_sales_button.text || 'Contact Sales'
              }}</SlpButton
            >
          </div>
          <SlpTypography
            v-if="data.tag_line"
            tag="p"
            variant="body1"
            class="slp-mb-24"
            >{{ data.tag_line }}</SlpTypography
          >
        </div>
      </SlpColumn>
      <SlpColumn
        v-if="data.image"
        :cols="6"
        class="slp-flex slp-align-items-center slp-justify-content-center"
      >
        <a :href="data.image.image_href" class="image-wrapper">
          <nuxt-img
            class="cta__image"
            :class="{ shadow: data.shadow, border: data.image_border }"
            :src="data.image.image_url"
            :alt="data.image.alt"
            loading="lazy"
          />
        </a>
      </SlpColumn>
      <SlpHorizontalRule
        v-if="data.horizontal_rule"
        class="slp-mb-64 slp-mt-64"
      />
    </SlpRow>
  </section>
</template>

<style lang="scss" scoped>
.cta {
  margin: $spacing-96 0;

  @media (max-width: $breakpoint-md) {
    margin-top: $spacing-16;
    margin-bottom: $spacing-48;
  }

  @media (max-width: $breakpoint-sm) {
    overflow-x: clip;
  }

  &.no-margin-bottom {
    margin-bottom: 0;
  }

  &__body {
    &--no-image {
      text-align: center;
      display: flex;
      flex-direction: column;
      justify-content: center;
      width: 100%;
    }

    &--text {
      margin: 0 auto;
      @media (min-width: $breakpoint-md) {
        width: 65%;
        margin-top: 20px;
      }
    }
  }

  &__header {
    text-align: center;

    @media (min-width: $breakpoint-md) {
      &:not(.centered) {
        text-align: left;
      }
    }
  }

  &__subtitle {
    display: block;
    font-size: 19px;
    margin-top: $spacing-24;
    margin-bottom: $spacing-16;

    @media (min-width: $breakpoint-md) {
      line-height: 28px;
      margin-bottom: unset;
    }

    &::v-deep &--subscript {
      font-size: 14px;
      display: inline-block;
      vertical-align: super;
      line-height: 18px;
    }
  }

  &__buttons {
    display: flex;
    flex-direction: column;

    &.centered {
      justify-content: center;
    }

    a {
      width: 100%;
      margin-bottom: $spacing-8;

      @media (min-width: $breakpoint-md) {
        width: inherit;
        margin-bottom: inherit;
      }
    }

    @media (min-width: $breakpoint-sm) {
      flex-direction: row;
    }
  }

  &__title-image {
    position: relative;
    display: inline-block;
  }
}

.cta__company-icon {
  height: 19px;
}

.image-wrapper {
  width: 100%;
}

.cta__image {
  max-height: 362px;
  max-width: 100%;

  &.border {
    border: 1px #f2f2f2 solid;
    border-radius: 6px;
  }

  &.shadow {
    box-shadow: 15px 15px 0 #f2f2f2;
    margin: 0 auto;
    max-width: 95%;
  }
}
</style>
